// Generated by the WOLips Templateengine Plug-in at 30 juil. 2013 16:58:54

/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.fwkcktldroitsperimetrerecherche.serveur.components;

import java.util.UUID;

import org.cocktail.fwkcktlajaxwebext.serveur.CktlAjaxWOComponent;
import org.cocktail.fwkcktlajaxwebext.serveur.CocktailAjaxSession;

import com.webobjects.appserver.WOContext;
import com.webobjects.eocontrol.EOEditingContext;

import er.extensions.eof.ERXEC;

/**
 * @author TODO
 *
 */
public class FwkCktlDroitsPerimetreRechercheComponent extends CktlAjaxWOComponent {

	private static final long serialVersionUID = 1L;
	public static final String BINDING_EDITING_CONTEXT = "editingContext";
	public static final String BINDING_UPDATE_CONTAINER_ID = "updateContainerID";
	public static final String BINDING_ISEDITING = "isEditing";
	private static final String BINDING_NEED_REFRESH = "needRefresh";
	private static final String SESSION_KEY_NOTIFICATION_CONTAINER_ID = "notificationContainerId";
	private EOEditingContext edc;

	/**
	 * @param context
	 *            le contexte
	 */
	public FwkCktlDroitsPerimetreRechercheComponent(WOContext context) {
		super(context);
	}

	@Override
	public CocktailAjaxSession session() {
		return (CocktailAjaxSession) super.session();
	}

	// Public Methods
	/**
	 * @param key
	 *            :identifiant de la chaine à localiser
	 * @return chaine localisée
	 */
	public String localisation(String key) {
		return mySession().localizer().localizedStringForKey(key);
	}
	
	@Override
	public EOEditingContext edc() {
		if (edc == null) {
			if (hasBinding(BINDING_EDITING_CONTEXT)) {
				edc = (EOEditingContext) valueForBinding(BINDING_EDITING_CONTEXT);
			} else {
				edc = ERXEC.newEditingContext();
			}
		}
		return edc;
	}

	public String getUpdateContainerID() {
		return (String) valueForBinding(BINDING_UPDATE_CONTAINER_ID);
	}

	public Boolean isEditing() {
		return booleanValueForBinding(BINDING_ISEDITING, false);
	}
	
	public Boolean getNeedRefresh() {
		return valueForBooleanBinding(BINDING_NEED_REFRESH, false);
	}

	/**
	 * @param needRefresh : parametre a passer au binding
	 */
	public void setNeedRefresh(Boolean needRefresh) {
		setValueForBinding(needRefresh, BINDING_NEED_REFRESH);
	}

	/**
	 * @return objet contenant les messages de notification
	 */
	public String notificationContainerId() {
		if (session().objectForKey(SESSION_KEY_NOTIFICATION_CONTAINER_ID) == null) {
			String notificationContainerId = "cktl_" + UUID.randomUUID().toString().replaceAll("-", "_") + "_notificationContainer";
			session().setObjectForKey(notificationContainerId, SESSION_KEY_NOTIFICATION_CONTAINER_ID);
		}

		return (String) session().objectForKey(SESSION_KEY_NOTIFICATION_CONTAINER_ID);
	}

}
